#pragma once
#include <Windows.h>
#include <cstdint>
#include <vector>
#include <memory>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition_variable.hpp>
#include "unpacked_image.h"

class image_window
{
public:
	explicit image_window(unpacked_image* image);

	void start();
	void show(int32_t x, int32_t y);
	void hide();
	void message_queue();

	void close();

	void reset(unpacked_image* image);

	void set_min_frame_time(uint32_t min_frame_time);

private:
	std::auto_ptr<unpacked_image> image_;
	uint32_t current_frame_;

	void setup_image();

	HWND dialog_;

	uint32_t min_frame_time_;

	static INT_PTR CALLBACK general_preview_func(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
	INT_PTR CALLBACK preview_func(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
};
