#pragma once
#include <Windows.h>
#include <vector>
#include <string>
#include <cstdint>
#include <boost/noncopyable.hpp>

class menu : boost::noncopyable
{
public:
	struct submenu
	{
	public:
		submenu(uint16_t id, const std::wstring& text);

		uint32_t get_id() const;
		const std::wstring& get_text() const;

	private:
		uint16_t id_;
		std::wstring text_;
	};

	typedef std::vector<submenu> submenu_list;

public:
	static void add_menu(HWND window, const std::wstring& text, const submenu_list& sumbenus);

	static bool has_menu(HWND window, const std::wstring& text);

private:
	menu();
};
