#pragma once
#include <cstdint>
#include <vector>
#include <Windows.h>
#include <GdiPlus.h>
#include <memory>
#include <boost/noncopyable.hpp>
#include <boost/ptr_container/ptr_vector.hpp>

class unpacked_image : boost::noncopyable
{
public:
	unpacked_image();
	explicit unpacked_image(Gdiplus::Bitmap* single_bitmap);

	uint32_t get_frame_count() const;
	void add_image(Gdiplus::Image* image, uint32_t frame_time);

	Gdiplus::Image& get_image(uint32_t index);
	uint32_t get_frame_time(uint32_t index) const;

	void set_min_frame_time(uint32_t min_frame_time);

	std::auto_ptr<unpacked_image> clone();

private:
	std::vector<uint32_t> frame_times_;
	boost::ptr_vector<Gdiplus::Image> frames_;
	uint32_t min_frame_time_;
};
